library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity test_2 is
	port (
	      clk     	 	   : in  std_logic;
	      P		     	   : in  std_logic_vector(6 downto 0);
	      ADC_data       : in  std_logic_vector(9 downto 0);
			rx		     	   : in  std_logic;
			P1     	 	   : out  std_logic;
	      tx		     	   : out std_logic;
			PHL	     	   : out std_logic;
			PPD	     	   : out std_logic;
			POE	     	   : out std_logic;
			POUT	     	   : out std_logic
	);
	end test_2;

architecture behav of test_2 is

shared variable count			: integer range 0 to 100 := 0;
shared variable tx_buzy			: bit := '0';
shared variable start_bit		: bit := '0';
shared variable stop_bit		: bit := '1';
signal ADC_data_buf				: std_logic_vector(9 downto 0);

shared variable rx_bit		: bit := '0';

begin
  
  --tx <= '1';
  PPD <= '0';
  POE <= '0';
  
  process (clk)
  begin
	 
	 if(clk'event and clk = '1') then
		
		if(rx = '0') then
	     rx_bit := '1';
	   end if;
		
		if(start_bit = '1') then
		  if(stop_bit = '0') then
		    count := count + 1;
		  end if;
		end if;
		
		if(count = 100) then
		  count := 0;
		  
		  P1 <= '1';
		  
		  if(P(6) = '0') then
		    start_bit := '0';
			 stop_bit := '1';
			 tx <= '1';
			 
			 rx_bit := '0';
			 
			 P1 <= '0';
			 
		  end if;
		  
	   end if;
		
	 end if;
	 
	 if(clk'event and clk = '0') then
		if(((count = 0) or (count = 25) or (count = 49) or (count = 73)) and (stop_bit = '0')) then
        ADC_data_buf <= ADC_data;
      end if;
	 end if;
	 
	 if(P(6) = '0') then
	   PHL <= '1';
	 end if;
	 if((P(6) = '1') and (rx_bit = '1')) then
	   stop_bit := '0';
	   PHL <= '0';
    end if;
	 
	 if(((count = 0) or (count = 20) or (count = 40) or (count = 60) or (count = 80)) and (stop_bit = '0')) then
      start_bit := '1';
		tx <= '0'; -- start bit
	 end if;
	 
	 if((count = 18) or (count = 38) or (count = 58) or (count = 78) or (count = 98)) then
      tx <= '1'; -- stop bit
	 end if;
    
	 if((count = 2) or (count = 26) or (count = 50) or (count = 74)) then
	   tx <= ADC_data_buf(0);
	 end if;
	 if((count = 4) or (count = 28) or (count = 52) or (count = 76)) then
	   tx <= ADC_data_buf(1);
	 end if;
	 if((count = 6) or (count = 30) or (count = 54) or (count = 82)) then
	   tx <= ADC_data_buf(2);
	 end if;
	 if((count = 8) or (count = 32) or (count = 56) or (count = 84)) then
	   tx <= ADC_data_buf(3);
	 end if;
	 if((count = 10) or (count = 34) or (count = 62) or (count = 86)) then
	   tx <= ADC_data_buf(4);
	 end if;
	 if((count = 12) or (count = 36) or (count = 64) or (count = 88)) then
	   tx <= ADC_data_buf(5);
	 end if;
	 if((count = 14) or (count = 42) or (count = 66) or (count = 90)) then
	   tx <= ADC_data_buf(6);
	 end if;
	 if((count = 16) or (count = 44) or (count = 68) or (count = 92)) then
	   tx <= ADC_data_buf(7);
	 end if;
	 if((count = 22) or (count = 46) or (count = 70) or (count = 94)) then
	   tx <= ADC_data_buf(8);
	 end if;
	 if((count = 24) or (count = 48) or (count = 72) or (count = 96)) then
	   tx <= ADC_data_buf(9);
	 end if;
	 
  end process;
end behav;